#define WIN32_LEAN_AND_MEAN

#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <tchar.h>
#include <richedit.h>
#include "rvEd.h"

#pragma resource "rvEd.res"

HINSTANCE hInstance;

//*****************************************************************************
void ToolBar_Init(HWND hDlg) {
//*****************************************************************************
  TBBUTTON tbb[22];
  TBADDBITMAP tbbmp;

  TB_ADD_BTN(tbb,0,0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0)
  TB_ADD_BTN(tbb,1,STD_FILENEW,IDM_FILE_NEW,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0)
  TB_ADD_BTN(tbb,2,STD_FILEOPEN,IDM_FILE_OPEN,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0)
  TB_ADD_BTN(tbb,3,STD_FILESAVE,IDM_FILE_SAVE,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0)
  TB_ADD_BTN(tbb,4,0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0)
  TB_ADD_BTN(tbb,5,STD_PRINT,IDM_FILE_PRINT,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0)
  TB_ADD_BTN(tbb,6,STD_PRINTPRE,IDM_FILE_PREVIEW,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0)
  TB_ADD_BTN(tbb,7,0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0)
  TB_ADD_BTN(tbb,8,STD_CUT,IDM_EDIT_CUT,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0)
  TB_ADD_BTN(tbb,9,STD_COPY,IDM_EDIT_COPY,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0)
  TB_ADD_BTN(tbb,10,STD_PASTE,IDM_EDIT_PASTE,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0)
  TB_ADD_BTN(tbb,11,0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0)
  TB_ADD_BTN(tbb,12,STD_FIND,IDM_EDIT_FIND,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0)
  TB_ADD_BTN(tbb,13,STD_REPLACE,IDM_EDIT_REPLACE,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0)
  TB_ADD_BTN(tbb,14,0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0)
  TB_ADD_BTN(tbb,15,STD_UNDO,IDM_EDIT_UNDO,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0)
  TB_ADD_BTN(tbb,16,STD_REDOW,IDM_EDIT_REDO,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0)
  TB_ADD_BTN(tbb,17,0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0)
  TB_ADD_BTN(tbb,18,STD_PROPERTIES,IDM_EDIT_PROPERTIES,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0)
  TB_ADD_BTN(tbb,19,0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0)
  TB_ADD_BTN(tbb,20,STD_HELP,IDM_HELP_ABOUT,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0)
  TB_ADD_BTN(tbb,21,0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0)
  
  tbbmp.hInst = HINST_COMMCTRL;
  tbbmp.nID = IDB_STD_SMALL_COLOR;

  SendDlgItemMessage(hDlg,IDC_TBR1,TB_BUTTONSTRUCTSIZE,(WPARAM)sizeof(TBBUTTON) , 0);
  SendDlgItemMessage(hDlg,IDC_TBR1,TB_ADDBITMAP, (WPARAM)12, (LPARAM) (LPTBADDBITMAP) &tbbmp );
  SendDlgItemMessage(hDlg,IDC_TBR1,TB_ADDBUTTONS, (WPARAM)22, (LPARAM) (LPTBBUTTON) &tbb);
  SendDlgItemMessage(hDlg,IDC_TBR1,TB_AUTOSIZE, 0, 0);  
}
  
//*****************************************************************************
void RichEdit_Init(HWND hDlg) {
//*****************************************************************************
  CHARFORMAT cf;
  
  cf.cbSize = sizeof(CHARFORMAT);
  cf.dwMask = CFM_FACE | CFM_SIZE;
  cf.yHeight = 9*20;
  strcpy(cf.szFaceName,"Courier New");

  SendDlgItemMessage(hDlg,IDC_RED1,EM_SETCHARFORMAT,(WPARAM)SCF_ALL ,(LPARAM)&cf);
}

//*****************************************************************************
BOOL MainDlg_OnInitDialog(HWND hDlg, HWND hwndFocus, LPARAM lParam) {
//*****************************************************************************
  ToolBar_Init(hDlg);
  RichEdit_Init(hDlg);
	return TRUE;
}

//*****************************************************************************
void MainDlg_OnCommand(HWND hDlg, int id, HWND hwndCtl, UINT codeNotify) {
//*****************************************************************************
	switch (id) { 
		case IDM_FILE_EXIT:
	  	PostMessage(hDlg, WM_CLOSE, 0, 0);
	}
}

//*****************************************************************************
void MainDlg_OnSize(HWND hDlg, UINT state, int cx, int cy) {
//*****************************************************************************
  HWND hTB,hSB,hRE;
  RECT rTB,rSB;
  int REh,REy;
      
  hTB = GetDlgItem(hDlg,IDC_TBR1);
  hSB = GetDlgItem(hDlg,IDC_SBR1);
  hRE = GetDlgItem(hDlg,IDC_RED1);

  SendMessage(hTB,WM_SIZE,0, 0);
  SendMessage(hSB,WM_SIZE,0, 0);
  
  GetWindowRect(hTB,&rTB);
  GetWindowRect(hSB,&rSB);

  REy = rTB.bottom - rTB.top;
  REh = cy - REy - (rSB.bottom - rSB.top);
  MoveWindow(hRE,0,REy,cx,REh,FALSE);

}

//*****************************************************************************
void MainDlg_OnClose(HWND hDlg) {
//*****************************************************************************
	EndDialog(hDlg,0);
}

//****************************************************************************
static LRESULT CALLBACK MainDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) {
//****************************************************************************

	switch (uMsg) {
		HANDLE_MSG(hDlg,WM_INITDIALOG,MainDlg_OnInitDialog);
		HANDLE_MSG(hDlg,WM_COMMAND,MainDlg_OnCommand);
		HANDLE_MSG(hDlg,WM_SIZE,MainDlg_OnSize);
		HANDLE_MSG(hDlg,WM_CLOSE,MainDlg_OnClose);
	}

	return FALSE;
}

//****************************************************************************
int PASCAL WinMain(HINSTANCE hInst, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int nCmdShow) {
//****************************************************************************
	WNDCLASSEX wcx;
	HMODULE hRichEditLib;
	INT_PTR Result;

  hInstance = hInst;		
	InitCommonControls();

	wcx.cbSize = sizeof(wcx);
	if (!GetClassInfoEx(NULL, MAKEINTRESOURCE(32770), &wcx))
		return 0;

	wcx.hInstance = hInstance;
	wcx.lpszClassName = _T("EsqueletoClass");
	if (!RegisterClassEx(&wcx)) return 0;

  hRichEditLib = LoadLibrary("RICHED20.DLL"); 		
  if (hRichEditLib) {
  	Result = DialogBox(hInstance, MAKEINTRESOURCE(IDD_DLG1), NULL, (DLGPROC)MainDlgProc);
	  FreeLibrary(hRichEditLib);	
	  return(Result);
	} 
  return 0;
}

//****************************************************************************
// END
//****************************************************************************
